package com.nisum.service;

import com.nisum.dao.Dao;
import com.nisum.dto.impl.EmployeeDto;
import com.nisum.model.Employee;
import com.nisum.model.impl.EmployeeImp;
import com.nisum.model.impl.JobRoleImp;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.Optional;

@Service
public class EmployeeService {

  @Autowired
  @Qualifier(value = "EmployeeDao")
  private Dao employeeDao;

  public Collection<EmployeeImp> getAllEmployees() { return employeeDao.getAll(); }

  public void createEmployee(EmployeeDto employeeDto) {
    EmployeeImp newEmployee = new EmployeeImp();
    newEmployee.setFirstName(employeeDto.getFirstName());
    newEmployee.setLastName(employeeDto.getLastName());

    JobRoleImp role=new JobRoleImp(employeeDto.getJobTitle());
    newEmployee.setJobRole(role);
    employeeDao.save(newEmployee);
  }

  public void updateEmployee(Integer employeeId, EmployeeDto updatedEmployee) {
    Optional employeeToUpdate = employeeDao.getById(employeeId);
    if (employeeToUpdate.isPresent()) {
      EmployeeImp newEmployee = (EmployeeImp) employeeToUpdate.get();
      newEmployee.set(updatedEmployee);
      employeeDao.update(newEmployee);
    }
  }
  public void deleteEmployee(Integer employeeId) {
    Optional employeeToDelete = employeeDao.getById(employeeId);
    if (employeeToDelete.isPresent()) {
      employeeDao.delete(employeeToDelete.get());
    }
  }

}
